/**
 * lab5.cpp
 *
 * EECS 183: Lab 5 - Exam 1 Review
 *
 * main() function for the lab assignment
 * 
 * NOTE: You will NOT submit this file to the autograder
 */
#include <iostream>
#include <string>

void testcalculateFrequency();
void testisValidPin();
int calculateFrequency(int num, int d);
void registerPin();

using namespace std;

int main() {
    cout << "-------------------------------" << endl
        << "EECS 183 Lab Menu Options" << endl
        << "-------------------------------" << endl;
    cout << "1 Execute testing for calculateFrequency()" << endl;
    cout << "2 Execute test cases for isValidPin()" << endl;
    cout << "3 Execute registerPin()" << endl;
    cout << "Any other number - Exit lab" << endl;
    cout << "Choice --> ";

    int choice;
    cin >> choice;

    // remove the return character from the cin stream buffer
    string junk;
    getline(cin, junk);

    if (choice == 1) {
        testcalculateFrequency();
    }
    else if (choice == 2) {
        testisValidPin();
    }
    else if (choice == 3) {
        registerPin();
    }
	return 0;
}


/**
* Requires: nothing
* Modifies: nothing
* Effects : executes premade test cases for calculateFrequency
*
* Note:     You will NOT need to write more test cases
**/
void testcalculateFrequency() {
    cout << "Testing calculateFrequency()\n";

    // test cases where frequency is 0
    int num = 9;
    int d = 1;
    int frequency = 0;
    int testResult = calculateFrequency(num, d);
    if (testResult != frequency) {
        cout << "\nFAILED: calculateFrequency(" << num << ", " << d << ")\n"
            << "Expected return value: " << frequency << endl
            << "Actual return value: " << testResult << endl;
    }

    num = 123;
    d = 0;
    testResult = calculateFrequency(num, d);
    if (testResult != frequency) {
        cout << "\nFAILED: calculateFrequency(" << num << ", " << d << ")\n"
            << "Expected return value: " << frequency << endl
            << "Actual return value: " << testResult << endl;
    }

    num = 222222;
    d = 9;
    testResult = calculateFrequency(num, d);
    if (testResult != frequency) {
        cout << "\nFAILED: calculateFrequency(" << num << ", " << d << ")\n"
            << "Expected return value: " << frequency << endl
            << "Actual return value: " << testResult << endl;
    }

    // test cases where frequency is 1
    num = 123;
    d = 2;
    frequency = 1;
    testResult = calculateFrequency(num, d);
    if (testResult != frequency) {
        cout << "\nFAILED: calculateFrequency(" << num << ", " << d << ")\n"
            << "Expected return value: " << frequency << endl
            << "Actual return value: " << testResult << endl;
    }

    num = 1231234123;
    d = 4;
    frequency = 1;
    testResult = calculateFrequency(num, d);
    if (testResult != frequency) {
        cout << "\nFAILED: calculateFrequency(" << num << ", " << d << ")\n"
            << "Expected return value: " << frequency << endl
            << "Actual return value: " << testResult << endl;
    }

    // test cases where frequency > 1
    num = 1231234123;
    d = 1;
    frequency = 3;
    testResult = calculateFrequency(num, d);
    if (testResult != frequency) {
        cout << "\nFAILED: calculateFrequency(" << num << ", " << d << ")\n"
            << "Expected return value: " << frequency << endl
            << "Actual return value: " << testResult << endl;
    }

    num = 100100110;
    d = 0;
    frequency = 5;
    testResult = calculateFrequency(num, d);
    if (testResult != frequency) {
        cout << "\nFAILED: calculateFrequency(" << num << ", " << d << ")\n"
            << "Expected return value: " << frequency << endl
            << "Actual return value: " << testResult << endl;
    }

    // test cases where frequency == #digits
    num = 222222;
    d = 2;
    frequency = 6;
    testResult = calculateFrequency(num, d);
    if (testResult != frequency) {
        cout << "\nFAILED: calculateFrequency(" << num << ", " << d << ")\n"
            << "Expected return value: " << frequency << endl
            << "Actual return value: " << testResult << endl;
    }

    num = 33333333;
    d = 3;
    frequency = 8;
    testResult = calculateFrequency(num, d);
    if (testResult != frequency) {
        cout << "\nFAILED: calculateFrequency(" << num << ", " << d << ")\n"
            << "Expected return value: " << frequency << endl
            << "Actual return value: " << testResult << endl;
    }

    cout << "Finished testing calculateFrequency()\n";
    return;
}

